function M=nbgen(v,nn)
% Usage: M=nbgen(v,nn)
% v: row vector, 1 X N
% nn (<N): a positive integer, usually = 2 or 3
% M: # of element that are different between M(i,:) and v = k
% 

if nn==1, 
   M=[]; % no distance 1 neighor
   return, 
end
N=length(v);
v=diag(diag(v))'; % make sure v is a row vector
M=[];
for i=1:N-nn+1, 
   if i==1, head=[]; elseif i>1, head=v(1:i-1); end
   for j=i+1:N-nn+2,
      if j==i+1, middle=[];  else middle=v(i+1:j-1); end
      if nn==2,  
         if j==N, ending=[]; elseif j<N, ending=v(j+1:N); end
         M=[M; [head v(j) middle v(i) ending]];
      elseif nn==3,
         for k=j+1:N-nn+3,
           if k==j+1, md2=[]; else md2=v(j+1:k-1); end
           if k==N, ending=[]; else ending=v(k+1:N); end
           M=[M;[head v(i) middle v(k) md2 v(j) ending]
              [head v(k) middle v(j) md2 v(i) ending]
              [head v(k) middle v(i) md2 v(j) ending]
              [head v(j) middle v(i) md2 v(k) ending]
              [head v(j) middle v(k) md2 v(i) ending]];
        end % k loop
     end % if nn
  end % j loop
end % i loop   
         